/*
 * Copyright IBM Corp. and others 1991
 *
 * This program and the accompanying materials are made available under
 * the terms of the Eclipse Public License 2.0 which accompanies this
 * distribution and is available at https://www.eclipse.org/legal/epl-2.0/
 * or the Apache License, Version 2.0 which accompanies this distribution
 * and is available at https://www.apache.org/licenses/LICENSE-2.0.
 *
 * This Source Code may also be made available under the following
 * Secondary Licenses when the conditions for such availability set
 * forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
 * General Public License, version 2 with the GNU Classpath
 * Exception [1] and GNU General Public License, version 2 with the
 * OpenJDK Assembly Exception [2].
 *
 * [1] https://www.gnu.org/software/classpath/license.html
 * [2] https://openjdk.org/legal/assembly-exception.html
 *
 * SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0-only WITH Classpath-exception-2.0 OR GPL-2.0-only WITH OpenJDK-assembly-exception-1.0
 */

/**
 * WARNING!!! GENERATED FILE
 *
 * This class is generated.
 * Do not use the Eclipse "Organize Imports" feature on this class.
 *
 * It can contain user content, but that content must be delimited with the
 * the tags
 * [BEGIN USER IMPORTS]
 * [END USER IMPORTS]
 *
 * or
 *
 * [BEGIN USER CODE]
 * [END USER CODE]
 *
 * These tags are entered as comments.  Characters before [ and after ] are ignored.
 * Lines between the tags are inserted into the newly generated file.
 *
 * IMPORTS are combined and inserted above newly generated imports.  CODE is combined
 * and inserted immediately after the class declaration
 *
 * All lines outside these tags are lost and replaced with newly generated code.
 */
package com.ibm.j9ddr.vm29.pointer.generated;

/*[BEGIN USER IMPORTS]*/
/*[END USER IMPORTS]*/

import com.ibm.j9ddr.CorruptDataException;
import com.ibm.j9ddr.vm29.pointer.*;
import com.ibm.j9ddr.vm29.structure.*;
import com.ibm.j9ddr.vm29.types.*;

/**
 * Structure: char4Pointer
 *
 * A generated implementation of a VM structure
 *
 * This class contains generated code and MAY contain hand written user code.
 *
 * Hand written user code must be contained at the top of
 * the class file, specifically above
 * the comment line containing WARNING!!! GENERATED CODE
 *
 * ALL code below the GENERATED warning will be replaced with new generated code
 * each time the PointerGenerator utility is run.
 *
 * The generated code will provide getters for all elements in the char4Pointer
 * structure.  Where possible, meaningful return types are inferred.
 *
 * The user may add methods to provide meaningful return types where only pointers
 * could be automatically inferred.
 */
@com.ibm.j9ddr.GeneratedPointerClass(structureClass=char4.class)
public class char4Pointer extends StructurePointer {

	// NULL
	public static final char4Pointer NULL = new char4Pointer(0);

/*[BEGIN USER CODE]*/
/*[END USER CODE]*/

	// Do not call this constructor.  Use static method cast instead.
	protected char4Pointer(long address) {
		super(address);
	}

	public static char4Pointer cast(AbstractPointer structure) {
		return cast(structure.getAddress());
	}

	public static char4Pointer cast(UDATA udata) {
		return cast(udata.longValue());
	}

	public static char4Pointer cast(long address) {
		if (address == 0) {
			return NULL;
		}
		return new char4Pointer(address);
	}

	public char4Pointer add(long count) {
		return char4Pointer.cast(address + (char4.SIZEOF * count));
	}

	public char4Pointer add(Scalar count) {
		return add(count.longValue());
	}

	public char4Pointer addOffset(long offset) {
		return char4Pointer.cast(address + offset);
	}

	public char4Pointer addOffset(Scalar offset) {
		return addOffset(offset.longValue());
	}

	public char4Pointer sub(long count) {
		return char4Pointer.cast(address - (char4.SIZEOF * count));
	}

	public char4Pointer sub(Scalar count) {
		return sub(count.longValue());
	}

	public char4Pointer subOffset(long offset) {
		return char4Pointer.cast(address - offset);
	}

	public char4Pointer subOffset(Scalar offset) {
		return subOffset(offset.longValue());
	}

	public char4Pointer untag(long mask) {
		return char4Pointer.cast(address & ~mask);
	}

	public char4Pointer untag() {
		return untag(UDATA.SIZEOF - 1);
	}

	protected long sizeOfBaseType() {
		return char4.SIZEOF;
	}

	// Implementation methods

	// I8 w
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_wOffset_", declaredType="I8")
	public I8 w() throws CorruptDataException {
		return new I8(getByteAtOffset(char4._wOffset_));
	}

	// I8 w
	public I8Pointer wEA() throws CorruptDataException {
		return I8Pointer.cast(nonNullFieldEA(char4._wOffset_));
	}

	// I8 x
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_xOffset_", declaredType="I8")
	public I8 x() throws CorruptDataException {
		return new I8(getByteAtOffset(char4._xOffset_));
	}

	// I8 x
	public I8Pointer xEA() throws CorruptDataException {
		return I8Pointer.cast(nonNullFieldEA(char4._xOffset_));
	}

	// I8 y
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_yOffset_", declaredType="I8")
	public I8 y() throws CorruptDataException {
		return new I8(getByteAtOffset(char4._yOffset_));
	}

	// I8 y
	public I8Pointer yEA() throws CorruptDataException {
		return I8Pointer.cast(nonNullFieldEA(char4._yOffset_));
	}

	// I8 z
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_zOffset_", declaredType="I8")
	public I8 z() throws CorruptDataException {
		return new I8(getByteAtOffset(char4._zOffset_));
	}

	// I8 z
	public I8Pointer zEA() throws CorruptDataException {
		return I8Pointer.cast(nonNullFieldEA(char4._zOffset_));
	}

}
